<?php defined('_JEXEC') or die('Restricted access');

/**
 * @version 2.0 $Id: categories.php,v 1.29 2011-03-25 21:38:40 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

jimport( 'joomla.application.component.model' );

require_once(JPATH_COMPONENT.DS.'classes'.DS.'LinkdirectoryURL.php');

/**
 * 
 */
class LinkDirectory2ModelCategories extends JModel {
	
	private $_id = 0;
	private $_parent = null;
	private $_ld = null;
	private $_categories = null;
	private $_paginationCategories = null;
	private $_paginationLinks = null;
	private $_searchLinks = null;
	private $_totalLinks = null;
	private $_queryLinks = null;
	private $_searchtext = null;
	private $_rows_of_categories = null;
	private $_totalCategories;

	public function __construct($cid = null){
		parent::__construct();
		$this->_ld=new LDConfig();
		if ($cid == null){
			$this->_id = JRequest::getInt( 'catid', 0, 'get' );
		} else {
			$this->_id = intval($cid);
		}
	}
	
	public function getParentCategoryId(){
		return $this->_id;
	}
	
	private function getTotalSubCategories(&$categoryId) {
		$user = JFactory::getUser();	
		$query = "SELECT count(*) FROM #__ldcats "
		. " WHERE parent_id = $categoryId "
		. " AND published = 1 "
		// TODO Auswertung des access wieder einbauen
		//. " AND access <= $user->gid"
		;
		$this->_db->setQuery($query);
		$totalsubcat = $this->_db->loadResult();
		return $totalsubcat;
	}
	
	/**
	 * Liefert ein Array mit allen Kategorien, deren Parent-Id gleich $_id ist.
	 * 
	 * @return Liste mit allen Kinder der jeweiligen Kategorie
	 */
	public function &getSubCategories() {
		$this->_db = &JFactory::getDBO();
		if (!$this->_categories){
			$categoriesOrder=$this->_ld->catorder;
			$query = "SELECT * FROM #__ldcats " 
			. " WHERE published = 1"
			// TODO Auswertung des access wieder einbauen
			//. " AND access <= $my->gid"
			. " AND parent_id = $this->_id"
			. " ORDER BY #__ldcats.$categoriesOrder "

			;

			$this->_db->setQuery( $query );
			$this->_categories =$this->_db->loadObjectList();
			
			foreach ($this->_categories as $category){
				$category->totalLinks = $this->getTotalPublishedLinksOfCategory($category->id);
				$category->totalSubCategories = $this->getTotalSubCategories($category->id);
				$category->subCategories= $this->getSubSubCategories($category->id);
			}
		}
		return $this->_categories;
	}
	
	private function &getSubSubCategories(&$catid) {
		$categoriesOrder=$this->_ld->catorder;
		$sublimit=$this->_ld->sublimit;
		$query = "SELECT * FROM #__ldcats"
		. " WHERE parent_id = $catid"
		. " AND published = 1"
		// TODO Auswertung des access wieder einbauen
		//. " AND access <= $my->gid"
		. " ORDER BY #__ldcats.$categoriesOrder "
		. " LIMIT 0,". ($sublimit+1)
		;
		$this->_db->setQuery($query);
		$subcats = $this->_db->loadObjectList();
		return $subcats; 
	}	
	
	/**
	 * Liefert den Titel der Parent-Kategorie.
	 * 
	 * @return title der Parent-Kategorie
	 */
	public function &getParent(){
		$this->_db = &JFactory::getDBO();
		if ($this->_parent == null){
			$query = "SELECT * FROM #__ldcats AS c " 
				. " WHERE c.published = 1"
				// TODO Auswertung des access wieder einbauen
				//. " AND access <= $my->gid"
				. " AND c.id = $this->_id"
				;
			$this->_db->setQuery( $query );	
			$this->_parent =$this->_db->loadObject();
		}
		return $this->_parent;		
	}
	
	// ===================================================================================
	// =                           Links                                                 =
	// ===================================================================================
	
	/**
	 * Liefert alle Links der Kategorie, die veröffentlicht sein. 
	 *
	 * @return Array mit allen Links einer Kategorie
	 */
	public function &getLinks() {
		if ($this->id == 0){
			return array();
		}
		if (!$this->_links){
			$query = "SELECT * FROM #__ldlinks"
			. " WHERE published = 1"
			// TODO Auswertung des access wieder einbauen
			//. " AND access <= $my->gid"
			. " AND catid = $this->_cid"
			. ' ORDER BY #__ldlinks.' . $this->_ld->linkorder
			;
			$this->_db->setQuery( $query );
			$this->_links =$this->_db->loadObjectList();
		}
		return $this->_links;
	}

	/**
	 * Liefert die Anzahl von veröffentlichen Links einer Kategorie.
	 * 
	 * @param int $categoryId Kategorie-ID
	 * @return Anzahl veröffentlichter Links einer Kategorie
	 */
	private function getTotalPublishedLinksOfCategory(&$categoryId) {
		$query = "SELECT count(*) FROM #__ldlinks "
		. " WHERE catid = $categoryId "
		. " AND published = 1 "
		;
		$this->_db->setQuery($query);
		$totallink = $this->_db->loadResult();
		return $totallink;
	}
	

	public function &getDataLinks() {
		$paginationLinks =& $this->getPaginationLinks();
		if (empty($this->_links)) {
			$query = $this->buildSearchLinks();
			$this->_links = $this->_getList($query, $paginationLinks->limitstart, $paginationLinks->limit);
		}
		return $this->_links;
	}

	public function &getPaginationLinks() {
		if(!$this->_paginationLinks) {
			jimport('joomla.html.pagination');
			$this->_paginationLinks = new JPagination($this->getTotalLinks(), JRequest::getVar('limitstart', 0), JRequest::getVar('limit', $this->_ld->limitlink));
		}
		return $this->_paginationLinks;
	}

	public function getTotalLinks() {
		if (!$this->_totalLinks) {
			$query = $this->buildSearchLinks();
			$this->_totalLinks = $this->_getListCount($query);
		}
		return $this->_totalLinks;
	}

	private function buildSearchLinks() {
		if (!$this->_queryLinks) {
			$search = $this->getSearchLinks();
			$this->_queryLinks = 'SELECT * FROM #__ldlinks l '
			                    .' WHERE l.published = 1 '
										// TODO Auswertung des access wieder einbauen
										// . " AND access <= $my->gid "  
								.' AND l.catid = ' . $search 
			                    .' ORDER BY l.' . $this->_ld->linkorder;
		}
		return $this->_queryLinks;
	}

	private function getSearchLinks() {
		if (!$this->_searchLinks) {
			$id = JRequest::getInt('catid',0);
			$this->_searchLinks = $id;
		}
		return $this->_searchLinks;
	}

	/**
	 * Liefert den PathWays der Kategorien. Wenn $cid gleich null ist, wird vesrucht, aus dem Request
	 * den Parameter catid zu lesen.
	 *
	 * @param int $cid Start-Kategorie (optinal)
	 * @return String, der den Path-Way inkl. Links auf die Kategorien enthält
	 */
	public function getLDPathWay($cid = null,$rootPathWayLabel) {
		if ($cid == null){
			$catid = JRequest::getInt( 'catid', 0, 'get' );
		} else {
			$catid = intval($cid);
		}
		$parent_id=1000;
		$user = JFactory::getUser();

		while ( $parent_id && ($catid != 0) ) {
			$query="SELECT * FROM #__ldcats WHERE id = $catid "
			. ' AND published = 1 '
			// TODO Auswertung des access wieder einbauen
			//. " AND access <= '" . $user->gid . "'"
			;

			$this->_db->setQuery( $query );
			$rows=$this->_db->loadObjectList();
			if ( $rows == null) return '';
			$row=$rows[0];
			if ( $row == null) return '';
			$parent_id=$row->parent_id;
			$id=$row->id;

			$name="<a class='ldpathway' href='" . JRoute::_(LinkdirectoryURL::getCatURL('categories',null,$catid)) ."'>" . $row->name . "</a>";

			if ( empty( $path ) ) {
				$path=$name;
			} else {
				$path=$name . ' - ' . $path;
			}
			$catid=$parent_id;
		}
		$home="<a class='ldpathway' href='" . JRoute::_(LinkdirectoryURL::getCatUrl('categories',null,0)) . "'>". $rootPathWayLabel ."</a>";

		if ( empty( $path ) ) {
			$pathName=$home . " ";
		} else {
			$pathName=$home . ' - ' . $path . " ";
		}
		return $pathName;
	}

	// ===================================================================================
	// =                           Suche                                                 =
	// ===================================================================================
	public function getSearchResult(){
		$this->_searchtext = JRequest::getString( 'searchtext', 0, 'get' );
		$catid = JRequest::getInt( 'catid', 0, 'get' );
		//$limitstart = JRequest::getInt( 'limitstart', 0, 'get' );
		$this->search($this->_searchtext,$catid);
		$result =  $this->_rows_of_categories;
		return $result;
	}
	
	private function search($searchtext, $catid) {
		$searchtext = $this->_db->getEscaped( trim( strtolower( $searchtext ) ) );
		$limitstart = JRequest::getInt( 'limitstart', 0, 'get' );
		if ($searchtext) {
			$where = array();
			$where[] = 'published = 1';
			$this->getWhereAllSubCategoriesForCats($catid,$where);
			$this->getWhereSearchtextForCat($searchtext,$where);
			$whereAsString = count( $where ) ? " WHERE " . implode( ' AND ', $where ) : "" ;
			$query = "SELECT * FROM #__ldcats " . $whereAsString . " LIMIT $limitstart, ".$this->_ld->limitlink;
			$this->_db->setQuery($query);
			$this->_rows_of_categories = $this->_db->loadObjectList();
		} else {
			$this->_rows_of_categories=NULL;
		}
		return $this->_rows_of_categories;
	}

	public function getSearchText(){
		if ($this->_searchtext == null){
			$this->_searchtext = JRequest::getString( 'searchtext', 0, 'get' );
		}
		return $this->_searchtext;
	}
	
	private function getTotal(){
		if(!$this->_totalCategories) {
			$this->_totalCategories=count($this->_rows_of_categories);
		}
		return $this->_totalCategories;
	}
	
	
	/**
	 * Liefert die Page Navigation für die Kategorien, wird nur für die Suche benötigt.
	 *
	 * @return Page Navigation für die Kategorien
	 */
	public function &getPageNavigation() {
		if(!$this->_paginationCategories) {
			jimport('joomla.html.pagination');
			$mainframe = JFactory::getApplication();
			$this->_paginationCategories = new JPagination($this->getTotal(), JRequest::getVar('limitstart', 0), JRequest::getVar('limit', $this->_ld->limitlink));
		}
		return $this->_paginationCategories;
	}
	
	/**
	 * Liefert where-Klausel, um Kategorien in der aktuellen und deren Unterkategorien suchen zu können.
	 *
	 * @param int $catid Katehorie-Id
	 * @param Array mit $where-Klausel, deren Elemente später mit AND verknüpft werden
	 * @global ld->searchonlyinsubcats
	 * @see #getWhereAllSubCategoriesFor
	 *
	 */
	private function getWhereAllSubCategoriesForCats($catid,&$where){
		require_once(JPATH_COMPONENT.DS.'classes'.DS.'SearchUtils.php');
		SearchUtils::getWhereAllSubCategoriesFor($catid,'id',$where);
	}

	/**
	 * Baut die where-Klausel bezüglich des Suchtextes für die Suche nach 
	 * Kategorien zusammen. Dabei wird berücksichtig, nach welchen 
	 * Feldern (tille, description) gesucht werden soll.
	 *
	 * @param String $searchtext Suchtext
	 * @param array $where where-Klausel
	 * @global $ld->searchcattitel
	 * @global $ld->searchcatdesc
	 */
	private function getWhereSearchtextForCat($searchtext,&$where){
		if ( $searchtext ) {
			$whereSearch = array();
			if ($this->_ld->searchcattitle){
				$whereSearch[] = "LOWER(name) LIKE '%$searchtext%'";
			}
			if ($this->_ld->searchcatdesc){
				$whereSearch[] = "LOWER(description) LIKE '%$searchtext%'";
			}
			$this->convertWhereArrayToString($whereSearch,'OR',$where);
		}
	}

	
	/**
	 * Konvertiert das Array $whereSearch in ein String, indem es die einzelnen Elemente mit $op verknüft.
	 * Das Ergebnis wird dem Array $where hinzugefügt. 
	 *
	 * @param array  $whereSearch
	 * @param String $op AND oder OR
	 * @param array $where (wird verändert)
	 */
	private function convertWhereArrayToString(&$whereSearch,$op,&$where){
		$count=count($whereSearch);
		if ($count > 1) {
			$where[] = '(' . implode( ' '.$op.' ', $whereSearch ) .')';
		}
		elseif ($count == 1) {
			$where[] = $whereSearch[0];
		}
		elseif ($count == 0) {
			$where[] = '1=0';
		}
	}
}
